/* linux/drivers/media/video/exynos/tv/mixer_vb2.c
 *
 * Copyright (c) 2011 Samsung Electronics Co., Ltd.
 *		http://www.samsung.com/
 *
 * Videobuf2 allocator operations file
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
*/
#include <linux/platform_device.h>
#if defined(CONFIG_VIDEOBUF2_CMA_PHYS)
#include <media/videobuf2-cma-phys.h>
#elif defined(CONFIG_VIDEOBUF2_DMA_CONTIG)
#include <media/videobuf2-dma-contig.h>
#endif

#include "mixer.h"

#if defined(CONFIG_VIDEOBUF2_CMA_PHYS)
void *mxr_cma_init(struct mxr_device *mdev)
{
	return vb2_cma_phys_init(mdev->dev, NULL, 0, false);
}

void mxr_cma_resume(void *alloc_ctx) {}
void mxr_cma_suspend(void *alloc_ctx) {}
void mxr_cma_set_cacheable(void *alloc_ctx, bool cacheable) {}

int mxr_cma_cache_flush(void *alloc_ctx, struct vb2_buffer *vb, u32 plane_no)
{
	return 0;
}

const struct mxr_vb2 mxr_vb2_cma = {
	.ops		= &vb2_cma_phys_memops,
	.init		= mxr_cma_init,
	.cleanup	= vb2_cma_phys_cleanup,
	.plane_addr	= vb2_cma_phys_plane_paddr,
	.resume		= mxr_cma_resume,
	.suspend	= mxr_cma_suspend,
	.cache_flush	= mxr_cma_cache_flush,
	.set_cacheable	= mxr_cma_set_cacheable,
};
#elif defined(CONFIG_VIDEOBUF2_DMA_CONTIG)
void *mxr_dma_contig_init(struct mxr_device *mdev)
{
	return vb2_dma_contig_init_ctx(mdev->dev);
}

const struct mxr_vb2 mxr_vb2_dma_contig = {
	.ops		= &vb2_dma_contig_memops,
	.init		= mxr_dma_contig_init,
	.cleanup	= vb2_dma_contig_cleanup_ctx,
	.plane_addr	= vb2_dma_contig_plane_dma_addr,
};
#endif
